;;; SUBST-EVAL-CBN.SCM
;;; 
;;; Call-by-name evaluation of INTEX+BIND programs using 
;;; the substitution model

;; Invoke a program on any number of integer values
(define subst-run-cbn
  (lambda (pgm ints)
    (literal-value
     (subst-eval-cbn 
      (subst* (map make-literal ints)
	      (program-formals pgm)
	      (program-body pgm))))))

;; SUBST-EVAL-CBN takes an expression and returns another expression 
;; (e.g., an integer literal node, *not* an integer) that is the
;; result of evaluting the expression. 
(define subst-eval-cbn
  (lambda (exp)
    (cond ((literal? exp) exp)
          ((varref? exp) 
           (throw 'unbound-variable (varref-name exp)))
          ((binapp? exp)
           ((binop-to-node-function (binapp-rator exp))
            (subst-eval-cbn (binapp-rand1 exp))
            (subst-eval-cbn (binapp-rand2 exp))))
          ((bind? exp)
           (subst-eval-cbn
            (subst1 (bind-defn exp) 
		    ;; *** Unlike CBV, DEFN is not evaluated in CBN ***
		    (bind-name exp)
		    (bind-body exp))))
          (else (error "SUBST-EVAL-CBN: Unknown expression type -- " exp))
          )))

;; Use BINOP-TO-NODE-FUNCTION from SUBST-EVAL-CBV.SCM

                                  

              
              
